-- Test quote_product_amount
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to numerus, auth, public;

select has_view('quote_product_amount');
select table_privs_are('quote_product_amount', 'guest', array[]::text[]);
select table_privs_are('quote_product_amount', 'invoicer', array['SELECT']);
select table_privs_are('quote_product_amount', 'admin', array['SELECT']);
select table_privs_are('quote_product_amount', 'authenticator', array[]::text[]);

select has_column('quote_product_amount', 'quote_product_id');
select col_type_is('quote_product_amount', 'quote_product_id', 'integer');

select has_column('quote_product_amount', 'subtotal');
select col_type_is('quote_product_amount', 'subtotal', 'integer');

select has_column('quote_product_amount', 'total');
select col_type_is('quote_product_amount', 'total', 'integer');


set client_min_messages to warning;
truncate quote_product_tax cascade;
truncate quote_product cascade;
truncate quote cascade;
truncate tax cascade;
truncate tax_class cascade;
truncate payment_method cascade;
truncate company cascade;
reset client_min_messages;

set constraints "company_default_payment_method_id_fkey" deferred;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, country_code, currency_code, default_payment_method_id)
values (1, 'Company 1', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', 'ES', 'EUR', 111)
;

insert into payment_method (payment_method_id, company_id, name, instructions)
values (111, 1, 'cash', 'cash')
;

set constraints "company_default_payment_method_id_fkey" immediate;

insert into tax_class (tax_class_id, company_id, name)
values (11, 1, 'tax')
;

insert into tax (tax_id, company_id, tax_class_id, name, rate)
values (2, 1, 11, 'IRPF -15 %', -0.15)
     , (3, 1, 11, 'IVA 4 %', 0.04)
     , (4, 1, 11, 'IVA 10 %', 0.10)
     , (5, 1, 11, 'IVA 21 %', 0.21)
;

insert into quote (quote_id, company_id, quote_number, quote_date, currency_code)
values ( 8, 1, 'I1', current_date, 'EUR')
     , ( 9, 1, 'I2', current_date, 'EUR')
     , (10, 1, 'I3', current_date, 'EUR')
     , (11, 1, 'I4', current_date, 'EUR')
;

insert into quote_product (quote_product_id, quote_id, name, price, quantity, discount_rate)
values (12,  8, 'P', 100, 1, 0.0)
     , (13,  8, 'P', 200, 2, 0.1)
     , (14,  9, 'P', 222, 3, 0.0)
     , (15,  9, 'P', 333, 4, 0.2)
     , (16, 10, 'P', 444, 5, 0.0)
     , (17, 10, 'P', 555, 6, 0.1)
     , (18, 11, 'P', 777, 8, 0.0)
;

insert into quote_product_tax (quote_product_id, tax_id, tax_rate)
values (12, 2, -0.15)
     , (12, 5,  0.21)
     , (13, 3,  0.04)
     , (14, 4,  0.10)
     , (14, 5,  0.21)
     , (14, 2, -0.07)
     , (15, 4,  0.10)
     , (16, 4,  0.10)
     , (16, 5,  0.21)
     , (17, 5,  0.21)
     , (17, 3,  0.04)
;   

select bag_eq(
	$$ select quote_product_id, subtotal, total from quote_product_amount $$,
	$$ values (12,  100,  106)
	        , (13,  360,  374)
	        , (14,  666,  826)
	        , (15, 1066, 1173)
	        , (16, 2220, 2908)
	        , (17, 2997, 3746)
	        , (18, 6216, 6216)
	$$,
	'Should compute the subtotal and total for all products.'
);

select *
from finish();

rollback;
